"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Skeleton = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const masked_view_1 = __importDefault(require("@react-native-masked-view/masked-view"));
const expo_linear_gradient_1 = require("expo-linear-gradient");
const react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
const skeletonItem_1 = require("./skeletonItem");
const Skeleton = ({ style, children }) => {
    const flattenStyle = react_1.useMemo(() => react_native_1.StyleSheet.flatten(style), [style]);
    const [skeletonWidth, setSkeletonWidth] = react_1.useState(0);
    const step = react_native_reanimated_1.useSharedValue(-1);
    const animatedStyle = react_native_reanimated_1.useAnimatedStyle(() => {
        return {
            transform: [{ translateX: step.value * skeletonWidth }]
        };
    });
    react_1.useEffect(() => {
        if (skeletonWidth) {
            step.value = react_native_reanimated_1.withRepeat(react_native_reanimated_1.withTiming(1, { duration: 1500 }), -1, false);
        }
    }, [skeletonWidth]);
    return (children ?
        <react_native_1.View style={Object.assign(Object.assign({}, flattenStyle), { opacity: 0.1 })} onLayout={(e) => {
                const { width } = e.nativeEvent.layout;
                setSkeletonWidth(width);
            }}>
        {children}
        <masked_view_1.default style={{ position: 'absolute', top: 0, left: 0, width: '100%', height: '100%' }} maskElement={<react_native_1.View style={Object.assign({ backgroundColor: 'transparent', width: '100%', height: '100%' }, flattenStyle)}>
              {children}
            </react_native_1.View>}>
          <react_native_1.View style={{ width: '100%', height: '100%', backgroundColor: '#7e7e7e' }}/>
          <react_native_reanimated_1.default.View style={[{ position: 'absolute', top: 0, left: 0, width: '100%', height: '100%', zIndex: 2 }, animatedStyle]}>
            <expo_linear_gradient_1.LinearGradient start={{ x: 0, y: 0 }} end={{ x: 1, y: 0 }} colors={['#7e7e7e', '#ffffff', '#7e7e7e']} style={{ width: '100%', height: '100%', backgroundColor: '#324376' }}/>
          </react_native_reanimated_1.default.View>
        </masked_view_1.default>
      </react_native_1.View>
        :
            <react_native_1.View style={[style, { opacity: 0.1 }]} onLayout={(e) => {
                    const { width } = e.nativeEvent.layout;
                    setSkeletonWidth(width);
                }}>
      <skeletonItem_1.SkeletonItem style={{ width: '100%', height: '100%', borderRadius: 20 }}/>
      <masked_view_1.default style={{ position: 'absolute', top: 0, left: 0, width: '100%', height: '100%' }} maskElement={<react_native_1.View style={{
                        backgroundColor: 'transparent',
                        width: '100%',
                        height: '100%'
                    }}>
            <skeletonItem_1.SkeletonItem style={{ width: '100%', height: '100%', borderRadius: flattenStyle === null || flattenStyle === void 0 ? void 0 : flattenStyle.borderRadius }}/>
          </react_native_1.View>}>
        <react_native_1.View style={{ width: '100%', height: '100%', backgroundColor: '#7e7e7e' }}/>
        <react_native_reanimated_1.default.View style={[{ position: 'absolute', top: 0, left: 0, width: '100%', height: '100%', zIndex: 2 }, animatedStyle]}>
          <expo_linear_gradient_1.LinearGradient start={{ x: 0, y: 0 }} end={{ x: 1, y: 0 }} colors={['#7e7e7e', '#ffffff', '#7e7e7e']} style={{ width: '100%', height: '100%', backgroundColor: '#324376' }}/>
        </react_native_reanimated_1.default.View>
      </masked_view_1.default>
    </react_native_1.View>);
};
exports.Skeleton = Skeleton;
//# sourceMappingURL=skeleton.js.map